<template>
    <div class="partner" v-if="ready">

        <div class="partner__wrapper">
            <div class="partner__content">
                <div class="partner__company-bar" style="background: #4e8bf5">
                    <p class="partner__company-bar-name">{{merchant.name}}</p>
                    <p class="partner__company-bar-description">Оплата частями на 3 и 6 месяцев</p>
                    <div class="partner__company-bar-wrapper-icon">
                        <img class="partner__company-bar-icon" :src="merchant.logo">
                    </div>
                </div>
                <div class="partner__navigation">
                    <div class="partner__category partner__column">
                        <div class="partner__row partner__space-between">
                            <p class="partner__navigation-title">Категория</p>
                        </div>
                        <div class="partner__navigation-info partner__column">
                            <div class="partner__category-icon-wrapper">
                                <img class="partner__category-icon"
                                     :src="merchant.logo"/>
                                <p class="partner__category-title">Электроника</p>
                            </div>
                            <div class="partner__category-tags">
                                <ScrollBar classes="my-scrollbar" ref="Scrollbar">
                                    <div class="scroll-me">
                                        <ul>
                                            <li v-for="tag in merchant.tags">
                                                <CategoryTag :key="tag.id" :title="tag.title" :link="tag.link"/>
                                            </li>
                                        </ul>
                                    </div>
                                </ScrollBar>
                            </div>
                        </div>
                    </div>
                    <div class="partner__address partner__column">
                        <div class="partner__row partner__space-between">
                            <p class="partner__navigation-title">Адреса магазинов</p>
                            <img class="partner__category-icon-title" src="/static/img/partner/shop-list.svg"/>
                        </div>
                        <div class="partner__navigation-info partner__row">
                            <ScrollBar classes="my-scrollbar" ref="Scrollbar">
                                <div class="scroll-me">
                                    <ul>
                                        <li v-for="shop in shops">{{shop.address}}</li>
                                    </ul>
                                </div>
                            </ScrollBar>
                        </div>
                    </div>
                    <div class="partner__on-map partner__column">
                        <div class="partner__row partner__space-between">
                            <p class="partner__navigation-title">На карте</p>
                            <img class="partner__category-icon-title" src="/static/img/partner/open-map.svg"/>
                        </div>
                        <div class="partner__navigation-map partner__row">
                            <div ref="mapContent" class="partner__yandex-map"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="partner__detailed-information">
                <div class="partner__row">
                    <p class="partner__detailed-information-title">Подробная информация</p>
                </div>
                <div class="partner__detailed-information-info partner__row">
                    <DetailedInformation v-for="item in merchant.details" :key="item.id"
                                         v-bind="item"/>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import DetailedInformation from '../DetailedInformation/index';
    import CategoryTag from '../CategoryTag';
    import ScrollBar from 'vue2-scrollbar';


    let mapScript;
    let map;
    export default {
        name: 'partnerDetails',
        props: {
            id: {
                required: true,
                type: Number
            }
        },

        components: {
            DetailedInformation,
            CategoryTag,
            ScrollBar
        },

        data() {
            return {
                merchant: {},
                shops: [],
                active: 'list',
                ready: false,
            };
        },

        created() {
            this.AJAX_LOADING(true);
            this.$store.dispatch('GET_INSTALLMENT_PARTNER_ID', this.id)
                .then(({ merchant, shop }) => {

                    if (!merchant.logo) {
                        merchant.logo = '/lk/static/img/pos/partner/default.png';
                    }

                    this.makeDetails(merchant);
                    this.makeTags(merchant);

                    this.merchant = merchant;
                    this.shops = shop;
                    this.createMarks();
                })
                .finally(() => {
                    this.AJAX_LOADING(false);
                    this.ready = true;
                });

            mapScript = document.createElement('script');
            mapScript.src = 'https://api-maps.yandex.ru/2.1/?lang=ru_RU&apikey=ba11ba61-24f5-4d5c-ae66-048c3978a95c';
            mapScript.onload = () => {
                this.createMap();
            };
            document.querySelector('head')
                .appendChild(mapScript);

        },

        beforeDestroy() {
            mapScript.remove();
        },

        methods: {

            makeTags(merchant) {
                merchant.tags = merchant.tags.split('#')
                    .map((tag) => {
                        const title = tag.trim();
                        const id = title;
                        const link = '';

                        return {
                            id,
                            title,
                            link
                        };
                    })
                    .filter(({ title }) => !!title);
            },

            makeDetails(merchant) {
                merchant.details = [];


                merchant.details.push({
                    title: 'Условия продажи',
                    value: merchant.installment,
                });

                if (merchant.worktime) {
                    merchant.details.push({
                        title: 'Время работы',
                        value: merchant.worktime
                    });
                }

                if (merchant.legal_name) {
                    merchant.details.push({
                        title: 'Юридическое лицо',
                        value: merchant.legal_name
                    });
                }

                if (merchant.name) {
                    merchant.details.push({
                        title: 'Название',
                        value: merchant.name
                    });
                }

                if (merchant.phone) {
                    merchant.details.push({
                        title: 'Контакты',
                        value: merchant.phone
                    });
                }

                if (merchant.website) {
                    merchant.details.push({
                        title: 'Сайт магазина',
                        value: merchant.website,
                        link: merchant.website
                    });
                }


            },

            createMap() {

                if (!this.$refs.mapContent) {
                    setTimeout(() => {
                        this.createMap();
                    }, 100);

                    return;
                }

                ymaps.ready(() => {
                    map = new ymaps.Map(this.$refs.mapContent, {
                            center: [this.$installment.location.lat || 55.751574, this.$installment.location.log || 37.573856],
                            zoom: 1,
                        },
                        {
                            searchControlProvider: 'yandex#search'
                        }
                    );
                    this.createMarks();
                });
            },

            createMarks() {
                if (!map) {
                    setTimeout(this.createMarks, 100);
                    return;
                }

                const MyIconContentLayout = ymaps.templateLayoutFactory.createClass(
                    '<div style="color: #FFFFFF; font-weight: bold;">$[properties.iconContent]</div>'
                );

                this.shops.forEach((shop) => {
                    const mark = new ymaps.Placemark([shop.latitude, shop.longitude], {
                        hintContent: shop.name,
                        balloonContent: shop.address,
                    }, {
                        // Опции.
                        // Необходимо указать данный тип макета.
                        iconLayout: 'default#imageWithContent',
                        // Своё изображение иконки метки.
                        iconImageHref: '/lk/static/img/pos/partner/map-marker.png',
                        // Размеры метки.
                        iconImageSize: [48, 48],
                        // Смещение левого верхнего угла иконки относительно
                        // её "ножки" (точки привязки).
                        iconImageOffset: [-24, -24],
                        // Смещение слоя с содержимым относительно слоя с картинкой.
                        iconContentOffset: [15, 15],
                        // Макет содержимого.
                        iconContentLayout: MyIconContentLayout
                    });
                    map.geoObjects.add(mark);
                });
            },

            showMap() {
                this.active = 'map';
                this.$nextTick(() => {
                    this.$helpers.scroll(this.$refs.map);
                });
            },

            go() {
                const url = this.merchant.website.startsWith('http') ? this.merchant.website : `http://${this.merchant.website}`;
                window.open(url, '_blank');

            }
        }
    };
</script>

<style scoped lang="scss">
    div.map {
        width: 100%;
        height: 400px;
    }
</style>
